ROOT=../schemas
ENTRY_STYLESHEET=${ROOT}/entry2html.xsl
ENTRY_XHTML11_STYLESHEET=${ROOT}/entry2xhtml11.xsl
ENTRY_ATOM_STYLESHEET=${ROOT}/atom/entry2atom.xsl
ENTRYSUMMARYSTYLESHEET=${ROOT}/entry2htmlsummary.xsl
ENTRY_TEXT_STYLESHEET=${ROOT}/entry2txt.xsl
ENTRY_LATEX_STYLESHEET=${ROOT}/entry2latex.xsl
ENTRY_MEDIAWIKI_STYLESHEET=${ROOT}/entry2mediawiki.xsl
ENTRY_DOCBOOK_STYLESHEET=${ROOT}/entry2docbook.xsl
RFC_STYLESHEET=${ROOT}/rfc2html.xsl
RFC_ATOM_STYLESHEET=${ROOT}/atom/rfc2atom.xsl
RFC_TEXT_STYLESHEET=${ROOT}/rfc2txt.xsl
RFC_LATEX_STYLESHEET=${ROOT}/rfc2latex.xsl
RFC_MEDIAWIKI_STYLESHEET=${ROOT}/rfc2mediawiki.xsl
RFC_DOCBOOK_STYLESHEET=${ROOT}/rfc2docbook.xsl
FICHE_STYLESHEET=${ROOT}/fichelec2html.xsl
FICHE_ATOM_STYLESHEET=${ROOT}/atom/fiche2atom.xsl
FICHE_TEXT_STYLESHEET=${ROOT}/fichelec2txt.xsl
FICHE_LATEX_STYLESHEET=${ROOT}/fichelec2latex.xsl
FICHE_MEDIAWIKI_STYLESHEET=${ROOT}/fichelec2mediawiki.xsl
MAX_TEX_RECURSION=4
XHTML11_DTD=/usr/share/xml/xhtml/schema/dtd/1.1/xhtml11-flat.dtd
ASY_COMMON=common.asy-include

XMLLINT=xmllint
XMLLINTARGS=--noout --relaxng ../schemas/${MYSCHEMA}

# TODO: not really exact since Trang does not resolve the include
%.rng: %.rnc common.rnc
	trang -I rnc -O rng $< $@

%.entry.html: %.entry_xml
	xsltproc -o $@ ${ENTRY_STYLESHEET} $^ 

%.entry.xhtml11: %.entry_xml common.xsl 
	xsltproc -o $@ ${ENTRY_XHTML11_STYLESHEET} $<
	# xmllint --noout --dtdvalid ${XHTML11_DTD} $@

# common-xhtml11.xsl: common.xsl
#	sed 's/exclude-result-prefixes = "str date xhtml"/exclude-result-prefixes = "str date"/' < $^> $@ || rm -f $@

%.atom: %.entry_xml
	xsltproc -o $@ \
		--stringparam filename `basename $< | sed 's/\.entry_xml$$//'` \
		${ENTRY_ATOM_STYLESHEET} $^ 

%.full_atom: %.entry_xml
	xsltproc -o $@ \
		--stringparam full true \
		--stringparam filename `basename $< | sed 's/\.entry_xml$$//'` \
		${ENTRY_ATOM_STYLESHEET} $^ 

%.tls_atom: %.entry_xml
	xsltproc -o $@ \
		--stringparam tls true \
		--stringparam filename `basename $< | sed 's/\.entry_xml$$//'` \
		${ENTRY_ATOM_STYLESHEET} $^ 

%.full_tls_atom: %.entry_xml
	xsltproc -o $@ \
		--stringparam full true \
		--stringparam tls true \
		--stringparam filename `basename $< | sed 's/\.entry_xml$$//'` \
		${ENTRY_ATOM_STYLESHEET} $^ 

%.entry_summary.html: %.entry_xml ${ENTRYSUMMARYSTYLESHEET}
	xsltproc -o $@ ${ENTRYSUMMARYSTYLESHEET} $<

%.entry.txt: %.entry_xml ${ENTRY_TEXT_STYLESHEET}
	xsltproc -o - \
		--stringparam filename `basename $< | sed 's/\.entry_xml$$//'` \
		${ENTRY_TEXT_STYLESHEET} $< > $@

%.entry.tex: %.entry_xml ${ENTRY_LATEX_STYLESHEET}
	xsltproc -o - \
		--stringparam filename `basename $< | sed 's/\.entry_xml$$//'` \
		${ENTRY_LATEX_STYLESHEET} $< > $@

%.entry.mediawiki: %.entry_xml ${ENTRY_MEDIAWIKI_STYLESHEET}
	xsltproc -o - \
		--stringparam filename `basename $< | sed 's/\.entry_xml$$//'` \
		${ENTRY_MEDIAWIKI_STYLESHEET} $< > $@

%.entry.db: %.entry_xml ${ENTRY_DOCBOOK_STYLESHEET}
	xsltproc -o - \
		--stringparam filename `basename $< | sed 's/\.entry_xml$$//'` \
		${ENTRY_DOCBOOK_STYLESHEET} $< > $@

%.fiche.html: %.fiche_xml
	xsltproc -o $@ ${FICHE_STYLESHEET} $^ 

%.atom: %.fiche_xml
	xsltproc -o $@ \
		--stringparam filename `basename $< | sed 's/\.fiche_xml$$//'` \
		${FICHE_ATOM_STYLESHEET} $^ 

%.full_atom: %.fiche_xml
	xsltproc -o $@ \
		--stringparam full true \
		--stringparam filename `basename $< | sed 's/\.fiche_xml$$//'` \
		${FICHE_ATOM_STYLESHEET} $^ 

%.tls_atom: %.fiche_xml
	xsltproc -o $@ \
		--stringparam tls true \
		--stringparam filename `basename $< | sed 's/\.fiche_xml$$//'` \
		${FICHE_ATOM_STYLESHEET} $^ 

%.full_tls_atom: %.fiche_xml
	xsltproc -o $@ \
		--stringparam full true \
		--stringparam tls true \
		--stringparam filename `basename $< | sed 's/\.fiche_xml$$//'` \
		${FICHE_ATOM_STYLESHEET} $^ 

%.fiche.txt: %.fiche_xml
	xsltproc -o - \
		--stringparam filename `basename $< | sed 's/\.fiche_xml$$//'` \
		${FICHE_TEXT_STYLESHEET} $< > $@

%.fiche.tex: %.fiche_xml ${FICHE_LATEX_STYLESHEET}
	xsltproc -o - \
		--stringparam filename `basename $< | sed 's/\.fiche_xml$$//'` \
		${FICHE_LATEX_STYLESHEET} $< > $@

%.rfc.html: %.rfc_xml
	xsltproc -o $@ ${RFC_STYLESHEET} $^ 

%.atom: %.rfc_xml
	xsltproc -o $@ \
		--stringparam filename `basename $< | sed 's/\.rfc_xml$$//'` \
		${RFC_ATOM_STYLESHEET} $^ 

%.full_atom: %.rfc_xml
	xsltproc -o $@ \
		--stringparam full true \
		--stringparam filename `basename $< | sed 's/\.rfc_xml$$//'` \
		${RFC_ATOM_STYLESHEET} $^ 

%.tls_atom: %.rfc_xml
	xsltproc -o $@ \
		--stringparam tls true \
		--stringparam filename `basename $< | sed 's/\.rfc_xml$$//'` \
		${RFC_ATOM_STYLESHEET} $^ 

%.full_tls_atom: %.rfc_xml
	xsltproc -o $@ \
		--stringparam full true \
		--stringparam tls true \
		--stringparam filename `basename $< | sed 's/\.rfc_xml$$//'` \
		${RFC_ATOM_STYLESHEET} $^ 

%.rfc.txt: %.rfc_xml ${RFC_TEXT_STYLESHEET}
	xsltproc -o - \
		--stringparam filename `basename $< | sed 's/\.rfc_xml$$//'` \
		${RFC_TEXT_STYLESHEET} $< > $@

%.rfc.tex: %.rfc_xml ${RFC_LATEX_STYLESHEET}
	xsltproc -o - \
		--stringparam filename `basename $< | sed 's/\.rfc_xml$$//'` \
		${RFC_LATEX_STYLESHEET} $< > $@

%.rfc.db: %.rfc_xml ${RFC_DOCBOOK_STYLESHEET}
	xsltproc -o - \
		--stringparam filename `basename $< | sed 's/\.rfc_xml$$//'` \
		${RFC_DOCBOOK_STYLESHEET} $< > $@

%.dvi: %.tex
	# Trick from Adam Di Carlo <adam@@onshore.com> to recurse latex 
	# "just enough".
	-cp -pf prior.aux pprior.aux
	-cp -pf $(shell basename $< .tex).aux prior.aux
	latex $<
	if ! cmp $(shell basename $< .tex).aux prior.aux &&             \
	   ! cmp $(shell basename $< .tex).aux pprior.aux &&            \
	   expr $(MAKELEVEL) '<' $(MAX_TEX_RECURSION); then             \
		rm -f $@                                               ;\
		$(MAKE) $@                                             ;\
	fi
	rm -f prior.aux pprior.aux

%.pdf: %.tex
	# Trick from Adam Di Carlo <adam@@onshore.com> to recurse latex 
	# "just enough".
	-cp -pf prior.aux pprior.aux
	-cp -pf $(shell basename $< .tex).aux prior.aux
	# TODO temporaire 2019-10-03 car certains fichiers font des erreurs Unicode. En attendant de passer à xetex, on fait taire make
	-pdflatex $< 
	if ! cmp $(shell basename $< .tex).aux prior.aux &&             \
	   ! cmp $(shell basename $< .tex).aux pprior.aux &&            \
	   expr $(MAKELEVEL) '<' $(MAX_TEX_RECURSION); then             \
		rm -f $@                                               ;\
		$(MAKE) $@                                             ;\
	fi
	rm -f prior.aux pprior.aux

%.eps: %.asy ${ASY_COMMON}
	asy -o $@ $<

%.pdf: %.asy ${ASY_COMMON}
	asy -f pdf -o $@ $<

%.png: %.asy ${ASY_COMMON}
	asy -f png -o $@ $<

%.webp: %.asy ${ASY_COMMON}
	asy -f webp -o $@ $<

%.gif: %.asy ${ASY_COMMON}
	asy -f gif -o $@ $<

# Or use rsvg <http://linux.about.com/library/cmd/blcmdl1_rsvg.htm> <http://seenthis.net/messages/86415>
%.png: %.svg
	# Previous versions of Inkscape (0.48) did the right thing but newer versions (0.91) export onely 1x1 image :-( We now need --export-area-drawing
	inkscape --export-area-drawing --export-png=$@ $<

%.pdf: %.svg
	inkscape  --export-area-drawing --export-pdf=$@ $<

%.gif: %.png
	convert -verbose $< $@

%.jpg: %.png
	# Most of my images are schemas, which suffer a lot with lossy
	# JPEG. Despite this, JPEG result is still poor :-(

        # -background white -flatten is here because transparent PNG
        # is otherwide badly handled and leads to all-black
        # images. http://www.imagemagick.org/discourse-server/viewtopic.php?t=24048
        # http://www.wizards-toolkit.org/discourse-server/viewtopic.php?f=3&t=20234 http://www.imagemagick.org/discourse-server/viewtopic.php?t=28214
	convert -verbose -quality '100%' -compress LossLess -background white -flatten $< $@

%.png: %.dot
	neato -Tpng $< > $@

%.svg: %.dot
	neato -Tsvg $< > $@

# TODO: a simple shell command to create a new entry, may be from a template to
# add things like entities definition? Not obvious that we really need it.

clean::
	rm -f *.html *.pdf *.mediawiki *.txt *~ *.rng *.atom *.tex *.dvi *.log *.aux

.DELETE_ON_ERROR:

## Local Variables: ##
## mode:makefile ##
## End: ##
