<?xml version='1.0' encoding="iso-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version='1.0'>
  
  <xsl:import href="common.xsl"/>
  
  <xsl:output omit-xml-declaration="yes"/>

  <xsl:template match="fiche">
    <h2><xsl:text>Fiche de lecture: </xsl:text><xsl:value-of select="@title"/></h2>
    <p>
      <xsl:text>Auteur(s) du livre: </xsl:text><xsl:apply-templates select="authors"/><br/>
      <xsl:text>diteur: </xsl:text><xsl:apply-templates select="editor"/><br/>
      <!-- TODO: turn ISBN into a link. There are possible services:
         http://xisbn.worldcat.org/xisbnadmin/doc/api.htm : Metadata includes only the pub. date and the language. Too poor.
         http://openlibrary.org/dev/docs : knows no book in French 
      -->
      <xsl:if test="@isbn">
        <xsl:value-of select="@isbn"/><br/>
      </xsl:if>
      <xsl:apply-templates select="pubyear"/><br/>
      <xsl:apply-templates select="date"/><br/>
      <xsl:if test="update_date">
        <xsl:apply-templates select="update_date"/><br/>
      </xsl:if>
    </p>
    <hr />
    <xsl:apply-templates select="content"/>
  </xsl:template>

  <xsl:template match="authors">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="author">
    <xsl:value-of select="text()"/><xsl:if test="following::author"><xsl:text>, </xsl:text></xsl:if>
  </xsl:template>

  <xsl:template match="editor">
    <xsl:value-of select="text()"/>
  </xsl:template>

  <xsl:template match="pubyear">
    <xsl:text>Publi en </xsl:text><xsl:value-of select="text()"/>
  </xsl:template>

</xsl:stylesheet>

