<?xml version='1.0' encoding="utf-8"?>
<!DOCTYPE stylesheet [
<!ENTITY newln "&#xA;">
]>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version='1.0'>
  
  <xsl:import href="common-latex.xsl"/>
  
  <xsl:output method="text" encoding="utf-8"/>

  <xsl:template match="authors">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="author">
    <xsl:value-of select="text()"/><xsl:if test="following::author"><xsl:text>, </xsl:text></xsl:if>
  </xsl:template>

  <xsl:template match="fiche">
    <xsl:call-template name="preamble"/>
    <xsl:text>&newln;</xsl:text>
    <xsl:call-template name="url_header"/>
    <!-- TODO: le style décale la première ligne du paragraphe. Il
         faudrait plutôt une vraie numération. On fait comment en
         LaTeX ? -->
    <xsl:text>Auteur(s)~: </xsl:text><xsl:apply-templates select="authors"/><xsl:text>\\</xsl:text>
    <xsl:text>ISBN n°</xsl:text><xsl:value-of select="/fiche/@isbn"/><xsl:text>\\</xsl:text>
    <xsl:text>Éditeur~: </xsl:text><xsl:call-template name="replace">
           <xsl:with-param name="content" select="editor/text()"/>
         </xsl:call-template><xsl:text>\\</xsl:text>
    <xsl:text>Publié en </xsl:text><xsl:value-of select="pubyear/text()"/><xsl:text>\\</xsl:text>
    <xsl:call-template name="end_header"/>
    <xsl:apply-templates select="content"/>
    <xsl:call-template name="postamble"/>
  </xsl:template>
  
</xsl:stylesheet>

