#!/usr/bin/python
# -*- encoding: utf-8 -*-

import os
import sys
import re
import locale
import io

from simpletal import simpleTAL, simpleTALES, simpleTALUtils
import psycopg2

import statutils

encoding = "utf-8"
statutils.encoding = encoding
base_uses_blog = False
general_tmpl_name = "general.tal_html"
tmpl_name =  "links-usage.tal_html"
title = u"Liens externes"

html_page = None
for directory in [os.environ['HOME'] + "/Blog/auto/",
                  "/var/www/www.bortzmeyer.org/auto/",
                  "/var/www/wsgis-bortzmeyer/auto/"]:
    if os.path.isfile(directory + tmpl_name):
        html_page = open(directory + tmpl_name)
        general_html_page = open(directory  + general_tmpl_name)
        break
if html_page is None:
    raise Exception("%s not found anywhere" % tmpl_name)
template = simpleTAL.compileXMLTemplate(html_page)
general_template = simpleTAL.compileXMLTemplate(general_html_page)
context = simpleTALES.Context()
general_context = simpleTALES.Context()
rendered = io.StringIO()
gal_rendered = io.StringIO()
 
conn = psycopg2.connect("dbname=blog")
cursor = conn.cursor()
cursor.execute("SET client_encoding TO '%s'" % encoding)
cursor.execute("SELECT count(id) FROM Blog.Links;")
context.addGlobal("num_links", int(cursor.fetchone()[0]))
results = []
int_results = {}
urls = []
cursor.execute("SELECT title, filename, url, Blog.num_uses(link) FROM Blog.Links, Blog.Links_Articles, Blog.Articles WHERE link = Blog.Links.id AND article = Blog.Articles.id ORDER BY Blog.num_uses(link) DESC, url;")
for result in cursor.fetchall():
    url = result[2]
    linkarticle = '/' + re.sub("\.xml$", ".html", result[1])
    if url not in int_results:
        urls.append(url)
        int_results[url] = {'count': result[3], 
                            'articles': [{'filename': linkarticle,
                                         'title': result[0]}, ]}
    else:
        int_results[url]['articles'].append({'filename': linkarticle,
                                             'title': result[0]})
        
for url in urls:
    results.append({'url': url, 'count': int_results[url]['count'], 'articles': int_results[url]['articles']})
    
context.addGlobal("links", results)
cursor.close()
conn.close()

general_context.addGlobal("time", statutils.current_datetime())
template.expand (context, rendered, outputEncoding=encoding, suppressXMLDeclaration=True)
general_context.addGlobal("content", rendered.getvalue())
general_context.addGlobal("title", title)
general_template.expand (general_context, gal_rendered, outputEncoding=encoding,
                         docType=statutils.doctype)
                         
print(gal_rendered.getvalue())  
