#!/usr/bin/python
# -*- encoding: iso-8859-1 -*-

import urllib2
import shutil
import subprocess
import os
import re
import time
import locale

import Parse

url="http://www.iana.org/assignments/ipv4-address-space/ipv4-address-space.xml"
assignment_file="ipv4-address-space.xml"
duration = 24 # Months
articleraw_name="../../entries/epuisement-adresses-ipv4-PLACEHOLDERS.entry_xml"
article_name="../../entries/epuisement-adresses-ipv4.entry_xml"

def display_of(num):
    if num < 40:
        return ("%i mois" % num)
    else:
        years = int(num / 12)
        months = num - (years*12)
        return ("%i annes et %i mois" % (years, months))

former_file = False
if os.path.exists(assignment_file):
    former_file = True
    shutil.copyfile(assignment_file, assignment_file + ".old")
    
# TODO: use If-Modified-Since to get the file only if it is new?
infile = urllib2.urlopen(url)
outfile = open(assignment_file, 'w')
for line in infile:
    outfile.write(line)
outfile.close()
infile.close()

# TODO: how to prevent it to print the differences between the files?
if former_file:
    result = subprocess.call(["diff", assignment_file + ".old", assignment_file])
if (not former_file or (former_file and result == 0)) and \
       os.path.exists(article_name): # No difference and the article
    # already exists
    pass
else:
    locale.setlocale(locale.LC_TIME, 'fr_FR')
    (unallocated, allocated_last_years) = Parse.analyze(assignment_file,
                                                 duration)
    now = time.time()
    remaining_months = unallocated * duration / len(allocated_last_years)
    remaining_months_reserve = (unallocated - 5) * duration / len(allocated_last_years)
    starvation = now + (remaining_months * (30.5 * 86400))
    replacements = {'UNALLOCATED': unallocated,
                    'UNALLOCATED_RESERVE': unallocated - 5,
                    'UPDATE_DATE': time.strftime("%Y-%m-%d",
                                                 time.localtime(now)),
                    'RECENTLY_ALLOCATED': len(allocated_last_years),
                    'DATE_STARVATION': time.strftime("%B %Y",
                                                     time.localtime(starvation)),
                    'TIME_REMAINING': display_of(remaining_months),
                    'TIME_REMAINING_RESERVE': display_of(remaining_months_reserve)
                    }
    inarticle = open(articleraw_name, 'r')
    outarticle = open(article_name, 'w')
    indata = inarticle.read()
    for token in replacements:
        indata = re.sub(token, str(replacements[token]), indata)
    inarticle.close()
    outarticle.write(indata)
    outarticle.close()

